/**
 * @file SplitBase.cpp
 * @brief Xvbgo[̊NXłB
 * @author Shinji Watanabe
 * @date Dec. 28, 2008
 */

#include "SplitBase.h"

//-----------------------------------------------------------------------------
/**
 * @brief RXgN^
 */
CSplitBase::CSplitBase()
{
	m_hWnd = NULL;
	m_hWnd2 = NULL;
	m_nMode = SPLIT_DUAL;
	m_pViews = NULL;
	m_bDrag = false;
	m_bVisible = false;
}


//-----------------------------------------------------------------------------
/**
 * @brief fXgN^
 *
 */
CSplitBase::~CSplitBase()
{
	DestroySplitBar();
}

//-----------------------------------------------------------------------------
/**
 * @brief \z
 */
 bool CSplitBase::Create(HWND hWndParent, HINSTANCE hInstance)
{
	if (!hWndParent || !hInstance)return false;
	
	// łɐς݂̏ꍇ͂j
	if ( m_hWnd )
	{
		DestroySplitBar();
	}
	
	// NXo^
	WNDCLASS wc;
	
#ifdef UNDER_CE
	wc.style			= 0;
#else	/*UNDER_CE*/
	// wc.style			= CS_BYTEALIGNCLIENT | CS_BYTEALIGNWINDOW;
	wc.style			= CS_BYTEALIGNCLIENT | CS_BYTEALIGNWINDOW | CS_DBLCLKS;// by Tetr@pod
#endif	/*UNDER_CE*/
	wc.lpfnWndProc		= SplitWinProc;
	wc.hInstance		= hInstance;
	wc.hIcon			= NULL;
	wc.hCursor			= NULL;						// ԂɂēKXύX
	wc.hbrBackground	= (HBRUSH)GetSysColorBrush(COLOR_BTNFACE);
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= SPLIT_WNDCLASSNAME;
	wc.cbClsExtra		= 0;						// gpȂB0w
	wc.cbWndExtra		= 0;						// gpȂB0w
	RegisterClass(&wc);								// EBhENX̓o^

	/*EBhE̍쐬*/
	m_hWnd = CreateWindowEx(0,SPLIT_WNDCLASSNAME,SPLIT_WNDCLASSNAME,
							WS_CHILD,0,0,0,0,hWndParent,NULL,hInstance,NULL);
	if (!m_hWnd)return false;
	m_hWnd2 = m_hWnd;
	
	/*vpeB̐ݒ*/
	SetProp(m_hWnd,SPLIT_PROPNAME,(HANDLE)this);
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief Xvbgo[폜܂
 */
void CSplitBase::DestroySplitBar()
{
	if (m_hWnd)
	{
		RemoveProp( m_hWnd, SPLIT_PROPNAME );
		DestroyWindow( m_hWnd );
		m_hWnd = NULL;
		m_hWnd2 = NULL;
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief EBhEvV[WłB
 */
LRESULT CALLBACK CSplitBase::SplitWinProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	CSplitBase *pSplitClass=NULL;	// ̃NXւ̃|C^
	pSplitClass=(CSplitBase*)GetProp(hWnd,SPLIT_PROPNAME);
	if (pSplitClass)
		return pSplitClass->MainProc(msg,wParam,lParam);
	else
		return DefWindowProc(hWnd,msg,wParam,lParam);
}


//-----------------------------------------------------------------------------
/**
 * @brief EBhEɊ֘AÂĂNXCX^Xłꍇɍs
 *		  ۂ̃EBhEvV[Wł
 */
LRESULT CSplitBase::MainProc(UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch(msg)
	{
	case WM_LBUTTONDOWN:
		//FOOTY2_PRINTF( L"Double Click A!\n" );
		OnMouseDown((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;
	case WM_MOUSEMOVE:
		OnMouseMove((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;
	case WM_LBUTTONUP:
		OnMouseUp((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;

	case WM_LBUTTONDBLCLK:// by Tetr@pod
		FOOTY2_PRINTF( L"Double Click A!\n" );
		OnMouseDouble((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;

	default:
		return DefWindowProc(m_hWnd,msg,wParam,lParam);
	}
	return false;
}

//-----------------------------------------------------------------------------
/**
 * @brief }EXƂ̏ł
 * @param	x	[in] }EXxW
 * @param	y	[in] }EXyW
 */
/*void CSplitBase::OnMouseDown(int x,int y)
{
	if (m_bDrag == false) {// by Tetr@pod
		SetCapture(m_hWnd);
		m_bDrag = true;
	}
}*/
// ʏɕύX

//-----------------------------------------------------------------------------
/**
 * @brief }EX̍{^Ƃ̏
 */
void CSplitBase::OnMouseUp(int x,int y)
{
	if (m_bDrag == true) {// by Tetr@pod
		ReleaseCapture();

		if (m_nMode == SPLIT_QUAD && m_pOtherSplit) {// ␳ by Tetr@pod
			m_pOtherSplit->MoveWin(m_pOtherSplit->GetX(),m_pOtherSplit->GetY(),m_nBaseWidth,m_nBaseHeight);
			MoveWin(m_x,m_y,m_nBaseWidth,m_nBaseHeight);
		}

		m_bDrag = false;
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief \Ԃݒł܂
 */
void CSplitBase::SetVisible(bool bVisible)
{
	ShowWindow(m_hWnd,bVisible ? SW_SHOWNORMAL : SW_HIDE);
}


//-----------------------------------------------------------------------------
/**
 * @brief eEBhEƂɌĂяoĂ
 */
void CSplitBase::OnBaseWindowMove(int x,int y,int nWidth,int nHeight)
{
	m_nBaseX = x;
	m_nBaseY = y;
	m_nBaseWidth = nWidth;
	m_nBaseHeight = nHeight;
}

/*[EOF]*/
